package hellojpa;

import java.util.*;
import javax.persistence.*;


public class TestJPA {

    @SuppressWarnings("unchecked")
    public static void main(String[] args) {
        // Create a new EntityManagerFactory using the System properties.
        // The "hellojpa" name will be used to configure based on the
        // corresponding name in the META-INF/persistence.xml file
        EntityManagerFactory factory = Persistence.createEntityManagerFactory("hellojpa");
        try {
	        // Create a new EntityManager from the EntityManagerFactory. The
	        // EntityManager is the main object in the persistence API, and is
	        // used to create, delete, and query objects, as well as access
	        // the current transaction
	        EntityManager em = factory.createEntityManager();
	
	        // Begin a new local transaction so that we can persist a new entity
	        em.getTransaction().begin();
	       
	        Grade biology = new Grade();
	        biology.setgName("Biology");
	        Student st1= new Student();
	        st1.setName("Kaloqn");
	       
	        st1.setzSing("Leo");
	        Student st2= new Student();
	        st2.setName("Marisa");
	   
	        st2.setzSing("Aries");
	        biology.addStudent(st1);
	        biology.addStudent(st2);
	        em.persist(biology);
	        
	        
	        em.getTransaction().commit();
	        
	        // Perform a simple query for all the Message entities
//	        Query query = em.createQuery("select m from Message m");
	        Query query2 = em.createQuery("select g from Grade g");
//	    	        
//	        for (Student s : (List<Student>) query1.getResultList()) {
//	            System.out.printf("Student %s with ID: %d and zodia %s \n", s.getName(), s.getId(), s.getzSing()); 
//	        }
	        for (Grade g : (List<Grade>) query2.getResultList()) {
	            System.out.printf("%s : %d \n", g.getgName(), g.getId() ); 
	            for (Student s: g.getStudent()){
	            	System.out.printf("Student %s with ID: %d and zodia %s \n", s.getName(), s.getId(), s.getzSing());
	            
		        }
	        }	
	        
	        // It is always good practice to close the EntityManager so that
	        // resources are conserved.
	        em.close();
        } finally {
        	factory.close();
        }
        
    }
}
